﻿-- 目标连击点大小
ComboFrame:SetScale(1.1)

-- 玩家与目标框架大小
TargetFrame:SetScale(1.1)
PlayerFrame:SetScale(1.1)

-- 仇恨百分比
--[[
local Font = TargetFrameNumericalThreatValue:GetFont()
TargetFrameNumericalThreatValue:SetFont(Font,13)
--]]


--[[目標和專注
hooksecurefunc("HealthBar_OnValueChanged", function(self, value, smooth)
    if (self.unit == "target" or self.unit == "focus") then
        --以下是HP百分比顯示
        local _, maxHealth = self:GetMinMaxValues()
        local hpPercent = ""
        if (maxHealth) then
            hpPercent = format("%.1f%%", self:GetValue() / maxHealth * 100)
        end
        if (not self.healthPercentString) then
            self.healthPercentString = self:CreateFontString(nil)
            self.healthPercentString:SetFont(SystemFont_Outline_Small:GetFont(), 13, "OUTLINE")
            self.healthPercentString:SetPoint("RIGHT", self, "TOP", -60, -15)
        end
        self.healthPercentString:SetText(hpPercent)
    end
end)
--]]
---头像职业着色
local colorbyclass = false


local function textUpdate(bar)
local textType = GetCVar("statusTextDisplay")
local frame = bar:GetParent()
if bar.StatusBar then bar=bar.StatusBar end
local value = bar:GetValue()
local _, max = bar:GetMinMaxValues()
if bar.pctText then
bar.pctText:SetText((textType ~= "NUMERIC" or value == 0) and "" or tostring(math.ceil((value / max) * 100)) .. "%")
end
if bar.TextString and frame.addPctText and textType == "NUMERIC" then
bar.TextString:SetText(value == 0 and "" or value)
end
end 

local function colorHPBar(bar, unit)
	if bar and not bar.lockValues and unit == bar.unit then
		local r, g, b
		local min, max = bar:GetMinMaxValues()
		local value = bar:GetValue()
		if max > min then
			value = (value - min) / (max - min)
		else
			value = 0
		end
		
		if value > 0.5 then
			r, g, b = 2*(1-value), 1, 0
		else
			r, g, b = 1, 2*value, 0
		end
		if not bar.disconnected and not bar.lockColor then
			if colorbyclass and UnitIsPlayer(unit) and UnitClass(unit) then
				local color = RAID_CLASS_COLORS[select(2, UnitClass(unit))]
				bar:SetStatusBarColor(color.r, color.g, color.b)
			else
				bar:SetStatusBarColor(r, g, b)
			end
		end
		if bar.pctText then bar.pctText:SetTextColor(r, g, b) end
	end
end

hooksecurefunc("TextStatusBar_UpdateTextString", textUpdate)
hooksecurefunc("UnitFrameHealthBar_Update", colorHPBar)
hooksecurefunc("HealthBar_OnValueChanged", function(self) colorHPBar(self, self.unit) end)


function CreateBarPctText(frame, ap, rp, x, y, font, manabar)
	local bar = ( manabar and frame.manabar ) or ( not manabar and frame.healthbar )
	if bar then
		if bar.pctText then
			bar.pctText:ClearAllPoints()
			bar.pctText:SetPoint(ap, bar, rp, x, y)
		else
			font = font or "NumberFontNormal"
			bar.pctText = frame:CreateFontString(nil, "OVERLAY", font)
			bar.pctText:SetPoint(ap, bar, rp, x, y)
			frame.addPctText = true
		end
	end
end

function SetNameColor(frame)
	if frame.name and frame.unit then
		local color = UnitIsPlayer(frame.unit) and RAID_CLASS_COLORS[select(2, UnitClass(frame.unit))] or NORMAL_FONT_COLOR
		frame.name:SetTextColor(color.r, color.g, color.b)
	end
end

function CreateClassIcon(parent, scale, ap, rp, x, y)
	local icon = CreateFrame("Button", nil, parent)
	icon:Hide()
	icon:SetWidth(31*scale)
	icon:SetHeight(31*scale)
	icon:SetFrameLevel(parent:GetFrameLevel()+3)
	icon:SetPoint(ap, parent, rp, x, y)

	icon.tex = icon:CreateTexture(nil, "BACKGROUND")
	icon.tex:SetWidth(20*scale)
	icon.tex:SetHeight(20*scale)
	icon.tex:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
	icon.tex:SetPoint("CENTER")

	icon.lay = icon:CreateTexture(nil, "OVERLAY")
	icon.lay:SetWidth(54*scale)
	icon.lay:SetHeight(54*scale)
	icon.lay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	icon.lay:SetPoint("TOPLEFT")

	return icon
end
--[[
function PVPIcon_Update(self)
	if not self.pvpIcon then return end
	local faction = UnitFactionGroup(self.unit)
	if UnitIsPlayer(self.unit) and faction then
		self.pvpIcon:SetTexture("Interface\\GroupFrame\\UI-Group-PVP-"..faction)
		self.pvpIcon:Show()
	else
		self.pvpIcon:Hide()
	end
end

function TinyTargetFrame_OnLoad(self)
	local prefix = self:GetName()
	local unit = self:GetParent().unit.."target"
	UnitFrame_Initialize(self, unit,  _G[prefix.."Name"], _G[prefix.."Portrait"], _G[prefix.."HealthBar"], nil, _G[prefix.."ManaBar"])
	SecureUnitButton_OnLoad(self, unit)
	RegisterUnitWatch(self)
	self.curName = nil
	self.pvpIcon = _G[prefix.."PVPIcon"]
	CreateBarPctText(self, "BOTTOM", "TOP", 2, 2)
end

local function PartyLevelText_Update(self)
	local level = ""
	if self.unit and UnitLevel(self.unit) and UnitLevel(self.unit) >= 1 then
		level = UnitLevel(self.unit)
	end
	if not self.levelText then
		self.levelText = _G[self:GetName()]:CreateFontString(nil, "OVERLAY", "NumberFontNormalYellow")
		self.levelText:SetPoint("TOPRIGHT", self, "BOTTOMLEFT", 24, 1)
	end
	self.levelText:SetText(level)
end

-- 目標框架&專注框架: 顯示職業顔色
-------------------------------------

hooksecurefunc("TargetFrame_Update", function(self)
    local _, class, color
    local unit = self.overrideName or self.unit
    if (self:IsShown() and UnitIsPlayer(unit)) then
        _, class = UnitClass(unit)
        color = RAID_CLASS_COLORS[class] or NORMAL_FONT_COLOR
        self.name:SetTextColor(color.r, color.g, color.b)
        self.name:SetText(UnitName(unit))
        if UnitIsFriend("player", unit) then
            self.nameBackground:SetVertexColor(0.2, 0.2, 0.2, 0.4)
            if (class == "DEATHKNIGHT") then
                self.name:SetTextColor(0.88, 0.32, 0.32)
            end
        elseif UnitIsEnemy("player", unit) then
            self.nameBackground:SetVertexColor(0.8, 0.1, 0.1, 0.6)
        end
    else
        self.name:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
    end
end)


------------------------------------
-- 目標的目標&專注目標的目標: 職業顔色
-------------------------------------

hooksecurefunc("UnitFrame_Update", function(self, isParty)
    local unit = self.unit
    if ((unit == "targettarget" or unit == "focus-target") and self:IsShown()) then
        local _, class, color
        if (UnitExists(unit)) then
            _, class = UnitClass(unit)
            color = RAID_CLASS_COLORS[class] or NORMAL_FONT_COLOR
            self.name:SetText(UnitName(unit))
            self.name:SetTextColor(color.r, color.g, color.b)
        end
    end
end)
--]]
-------------------
------ 血量百分比 -------
---------------------
CreateBarPctText(PlayerFrame, "LEFT", "top", 63, -15, "NumberFontNormalLarge")-----自身头像百分比位置，系统自带改25.30
CreateBarPctText(PetFrame, "LEFT", "top", 35, -5)-----宠物栏头像百分比位置
PetFrameHealthBarText:SetTextHeight(9)
PetFrameManaBarText:SetTextHeight(9)
	
for i = 1, 4 do
	local frame = "PartyMemberFrame"..i
	CreateBarPctText(_G[frame], "LEFT", "RIGHT", 6, 0)
	_G[frame.."HealthBarText"]:SetTextHeight(9)
	_G[frame.."ManaBarText"]:SetTextHeight(9)
end

CreateBarPctText(TargetFrame, "RIGHT", "top", -60, -15, "NumberFontNormalLarge")-----目标头像百分比位置,系统自带改-25.30
CreateBarPctText(TargetFrameToT, "BOTTOMLEFT", "TOPRIGHT", 2, -10)------目标的目标百分比位置
CreateBarPctText(FocusFrame, "RIGHT", "top", -65, -15, "NumberFontNormalLarge")-----焦点头像百分比位置
CreateBarPctText(FocusFrameToT, "BOTTOMLEFT", "TOP", 28, -10)

for i = 1, MAX_BOSS_FRAMES do
	local bossFrame = _G["Boss"..i.."TargetFrame"]
	CreateBarPctText(bossFrame, "BOTTOMLEFT", "TOPRIGHT", 17, 18, "NumberFontNormalLarge")
end

TargetFrame.type = TargetFrame:CreateFontString(nil, "OVERLAY", "ReputationDetailFont")
TargetFrame.type:SetPoint("BOTTOMRIGHT", TargetFrameNameBackground, "TOPRIGHT", -11, 5)

TargetFrame.icon = CreateClassIcon(TargetFrame, 1, "TOPRIGHT", "TOPRIGHT", -87, -4)
TargetFrame.icon:SetScript("OnClick", function() if IsAltKeyDown() then InitiateTrade("target") else InspectUnit("target") end end)
FocusFrame.icon = CreateClassIcon(FocusFrame, 1, "TOPLEFT", "TOPLEFT", 114, -4)

--------简化血量字体------------- 
local f=function(v)
   if (v >= 1e8) then
	  return ("%.2f亿"):format(v / 1e8)

   elseif(v >= 1e4) then 
	  return ('%.2f万'):format(v / 1e4) 
   else 
	  return ("%d"):format(v/1)
   end 
end 

hooksecurefunc("TextStatusBar_UpdateTextString",function(s) 
	if not GetCVarBool("statusTextPercentage") then 
		if 	s.TextString and s.currValue then 
			s.TextString:SetText(f(s:GetValue())) 
		end
		if 	s.RightText and s.currValue then
			s.RightText:SetText(f(s:GetValue()))
		end 
	end 
end)
